﻿using UnityEngine;
using System.Collections;

public class BotBehavior : MonoBehaviour {
	protected float tmpTime;
	protected float nextAction;
	protected float disableTime; //temps minimum pour revenir au comportement initial
	protected bool trigger; // un comportement est en cours ou non
	protected float behaviorTime; // duree d'un comportement


	// Use this for initialization
	void Start () {
		nextActionTime ();
		tmpTime = Time.time;
		trigger = false;
		behaviorTime = 0.4f;
	}
	
	// Update is called once per frame
	void Update () {
		if (trigger && Time.time > disableTime) {
			initialBehavior ();
		}

		if (nextAction + tmpTime <= Time.time) {
			behaviorTriggered ();
			nextActionTime ();
			GameObject.Find ("_GM").GetComponent<ControllerScript> ().behaviorChanged ();
			tmpTime = Time.time;
		}

	}

	void nextActionTime(){
		nextAction = Random.Range (2, 6);
	}

	void behaviorTriggered(){
		trigger = true;
		disableTime = Time.time + behaviorTime;
		int varTmp = (int) Random.Range (1, 3);
		GameObject[] bots = GameObject.FindGameObjectsWithTag ("Bot");
		foreach (GameObject bot in bots) {
			bot.GetComponent<Animator> ().SetInteger ("behavior", varTmp);
		}
	}

	void initialBehavior(){
		GameObject[] bots = GameObject.FindGameObjectsWithTag ("Bot");
		foreach (GameObject bot in bots) {
			bot.GetComponent<Animator> ().SetInteger ("behavior", 0);
		}
		trigger = false;
	}


}
